;srirq.asm
;
;include <srdefn>
;
IntVctr equ     $0100
IRQ     equ     8
;
; Connect to IRQ Interrupts
;
xref    ConBInt_        ; system routine - create interrupt connection
;
xdef    SRConnect_
SRConnect_  equ  *
  LDD  IntVctr+IRQ      ; get address of current IRQ handler
  STD  IRQHndlr         ; save old IRQ handler address
  LDD  #IRQ             ; install new IRQ handler
  PSHS D                ;
  LDD  #SRIRQHndlr      ;
  JSR  ConBInt_         ;
  LEAS 2,S              ; pop parameter
  RTS                   ; return to caller
;
; Disconnect from IRQ Interrupts
;
;
xdef    SRDisconnect_
SRDisconnect_  equ  *
  LDD  IRQHndlr         ; get old IRQ handler address
  STD  IntVctr+IRQ      ; restore IRQ handler address
  CLRA                  ; indicate that the
  CLRB                  ; disconnection has been made
  STD  IRQHndlr         ;
  RTS                   ; return to caller
;
xref    ACIAHOST_       ; ACIA base address
xref    SRIntH          ; new ACIA handler
;
xdef    SRIRQHndlr
SRIRQHndlr  equ  *
  LDA ACIAHOST_+STATR   ; get host ACIA status
  if lt                 ; if INTERRUPT bit is on then
    JSR SRIntH          ; - call new ACIA handler
  else                  ; else
    JMP [IRQHndlr]      ; - call regular IRQ handler
  endif                 ; endif
  RTS                   ; end of IRQ handler routine

  end
